﻿using System;
using System.Threading;
using System.Threading.Tasks;
using Messages;

using MiniBuss;
using System.Configuration;

namespace Publisher
{
    class Program
    {
        static void Main()
        {
            var bus = new ServiceBus { LocalEndpoint = ConfigurationManager.AppSettings["LocalEndpoint"].ToString() };

            bus.HandleSubscriptionsFor<SomethingHappenedEvent>();

            bus.Start();    

            Task.Factory.StartNew(() => PublishingThread(bus), TaskCreationOptions.LongRunning);

            Console.WriteLine("Working, press ENTER to exit");
            Console.ReadLine();
        }

        private static void PublishingThread(IServiceBus bus)
        {
            int i = 1;
            while (true)
            {
                var guid = Guid.NewGuid();
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine(i.ToString()+"......Publishing event with guid " + guid);
                bus.Publish(new SomethingHappenedEvent { Guid = guid, Sent = DateTime.Now });
                Thread.Sleep(1000);
                i++;
            }
        }
    }
}
