﻿using System;
using System.Configuration;

namespace Subscriber1
{
    /// <summary>
    /// This subscriber is using local message classes which looks the same as the ones sent by the publisher.
    /// Namespace doesn't matter, just use the same class and property names.
    /// </summary>
    class Program
    {
        //多个订阅功能:通过读取同一个消息队列，不同的回执
        static void Main()
        {
            //回执
            var bus = new MiniBuss.ServiceBus { LocalEndpoint = ConfigurationManager.AppSettings["LocalEndpoint"].ToString() };

            bus.Start();

            //消息发送
            bus.Subscribe<SomethingHappenedEvent>(ConfigurationManager.AppSettings["TargetEndpoint"].ToString(), @event =>
            {
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine("something happened at {0}, event id {1}",
                    @event.Sent, @event.Guid);
            });

            Console.WriteLine("Waiting for events, press ENTER to exit");
            Console.ReadLine();

            bus.UnSubscribe<SomethingHappenedEvent>("minibuss_publisher1");
        }   
    }

    public class SomethingHappenedEvent
    {
        public Guid Guid { get; set; }
        public DateTime Sent { get; set; }
    }
}