﻿using System;
using Messages;
using System.Configuration;

namespace Subscriber2
{
    /// <summary>
    /// This subscriber is sharing the message assembly with the publisher. See subscriber1 on how
    /// to use local message classes.
    /// </summary>
    class Program
    {
        //多个订阅功能:通过读取同一个消息队列，不同的回执
        static void Main()
        {
            //回执队列
            var bus = new MiniBuss.ServiceBus { LocalEndpoint = ConfigurationManager.AppSettings["LocalEndpoint"].ToString() };

            bus.Start();

            //发送队列
            bus.Subscribe<SomethingHappenedEvent>(ConfigurationManager.AppSettings["TargetEndpoint"].ToString(), @event =>
            {
                Console.ForegroundColor = ConsoleColor.Green;
                Console.WriteLine("something happened at {0}, event id {1}",
                    @event.Sent, @event.Guid);
            });
            
            Console.WriteLine("Waiting for events, press ENTER to exit");
            Console.ReadLine();

            bus.UnSubscribe<SomethingHappenedEvent>("minibuss_publisher1");
        }
    }
}
